﻿/* CommentPoolTest.cs
 * part of zaaReloaded2
 * 
 * Copyright 2015 Daniel Kraus
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NUnit.Framework;
using zaaReloaded2.Controller.Comments;

namespace Tests.Controller.Comments
{
    [TestFixture]
    class CommentPoolTest
    {
        [Test]
        public void CreateCommentIfDoesNotExist()
        {
            CommentPool.Default.Reset();
            int n = CommentPool.Default.Count;
            ItemComment i = CommentPool.Default.GetCommentFor("item \"<>\"");
            Assert.AreEqual(n + 1, CommentPool.Default.Count);
        }

        [Test]
        public void ReturnExistingComment()
        {
            ItemComment i = CommentPool.Default.GetCommentFor("item \"<>\"");
            int n = CommentPool.Default.Count;
            i = CommentPool.Default.GetCommentFor("item \"<>\"");
            Assert.AreEqual(n, CommentPool.Default.Count);
        }

        [Test]
        public void BuildingCommentRaisesEvent()
        {
            ItemComment i = CommentPool.Default.GetCommentFor("item \"<>\"");
            int eventRaised = 0;
            CommentPool.Default.FillInComment += (sender, args) =>
            {
                eventRaised += 1;
            };
            string comment = i.BuildComment();
            Assert.AreEqual(1, eventRaised);
        }
    }
}
