﻿/* ItemCommentTest.cs
 * part of zaaReloaded2
 * 
 * Copyright 2015 Daniel Kraus
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NUnit.Framework;
using zaaReloaded2.Formatter;
using zaaReloaded2.Controller.Comments;

namespace Tests.Controller.Comments
{
    [TestFixture]
    class ItemCommentTest
    {
        [Test]
        public void FactoryWithGoodDefinition()
        {
            ItemComment i = ItemComment.FromDefinitionString("TAC \"(Zielbereich: <4-7> µg/l)\"");
            Assert.IsNotNull(i);
            Assert.AreEqual("(Zielbereich: ", i.Prefix);
            Assert.AreEqual("4-7", i.Value);
            Assert.AreEqual(" µg/l)", i.Suffix);
            Assert.AreEqual("TAC", i.Item);
            Assert.AreEqual("(Zielbereich: 4-7 µg/l)", i.BuildComment());
        }

        [Test]
        public void FactoryWithBadDefinition()
        {
            ItemComment i = ItemComment.FromDefinitionString("some bogus definition");
            Assert.IsNull(i);
        }

        [Test]
        public void EmptyValueProducesEmptyComment()
        {
            ItemComment i = ItemComment.FromDefinitionString("TAC \"(Zielbereich: <default> µg/l)\"");
            i.Value = String.Empty;
            Assert.AreEqual(String.Empty, i.BuildComment());
        }
    }
}
