﻿/* SettingsTest.cs
 * part of zaaReloaded2
 * 
 * Copyright 2015 Daniel Kraus
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NUnit.Framework;
using zaaReloaded2.Controller;
using zaaReloaded2.Controller.Elements;
using System.IO;

namespace Tests.Controller
{
    [TestFixture]
    class SettingsTest
    {
        [Test]
        public void CloneSettings()
        {
            SelectEachDay selectEachDay = new SelectEachDay();
            Items items = new Items("some text");
            Settings source = new Settings(
                "hello world",
                new List<ElementBase>() { selectEachDay, items });
            source.ReferenceStyle = zaaReloaded2.Formatter.ReferenceStyle.IfSpecialOrAbnormal;
            Settings clone = source.Clone() as Settings;
            Assert.AreNotSame(source, clone);
            Assert.AreEqual("Kopie von " + source.Name, clone.Name,
                "Name");
            Assert.AreNotSame(source.Elements, clone.Elements);
            Assert.AreEqual(source.ReferenceStyle, clone.ReferenceStyle,
                "ReferenceStyle");
            Assert.AreEqual(
                ((Items)source.Elements[1]).Content,
                ((Items)clone.Elements[1]).Content,
                "Items content");
        }
    }
}
