﻿/* TestHelpers.cs
 * part of zaaReloaded2
 * 
 * Copyright 2015 Daniel Kraus
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using zaaReloaded2.Importer.ZaaImporter;

namespace Tests
{
    class TestHelpers
    {
        /// <summary>
        /// Creates a ZaaImporter object and imports demo-output.txt.
        /// </summary>
        /// <returns></returns>
        public static ZaaImporter ZaaImporterFromResource()
        {
            Stream s = typeof(TestHelpers).Assembly.GetManifestResourceStream("Tests.demo-output.txt");
            StreamReader r = new StreamReader(s);
            ZaaImporter importer = new ZaaImporter();
            importer.Import(r.ReadToEnd());
            return importer;
        }
    }
}
