﻿/* ParametersTest.cs
 * part of zaaReloaded2
 * 
 * Copyright 2015 Daniel Kraus
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NUnit.Framework;
using zaaReloaded2.Thesaurus;

namespace Tests.Thesaurus
{
    [TestFixture]
    class ParametersTest
    {
        [Test]
        public void GetCanonicalName()
        {
            Assert.AreEqual("CRP",
                Parameters.Default.GetCanonicalName("C-reaktives Protein"));
        }

        [Test]
        public void GetPrecision()
        {
            Assert.AreEqual(1,
                Parameters.Default.GetPrecision("Creatinin"));
        }

        [Test]
        public void GetForceReferenceDisplay()
        {
            Assert.IsTrue(Parameters.Default.GetForceReferenceDisplay("Magnesium"));
        }

        [Test]
        public void GetIsBlacklisted()
        {
            Assert.IsTrue(Parameters.Default.GetIsBlacklisted("glomerul. Filtrationsr. (MDRD)"));
        }
    }
}
