﻿/* ElementPickerViewModelTest.cs
 * part of zaaReloaded2
 * 
 * Copyright 2015 Daniel Kraus
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NUnit.Framework;
using Bovender.Mvvm.ViewModels;
using zaaReloaded2.ViewModels;

namespace Tests.ViewModels
{
    [TestFixture]
    class ElementPickerViewModelTest
    {
        [Test]
        public void ChooseElement()
        {
            ElementPickerViewModel vm = new ElementPickerViewModel(true);
            ViewModelBase elementVM = vm.Categories.First().Children.First();
            elementVM.IsSelected = true;
            string expectedLabel = elementVM.DisplayString;

            Assert.IsTrue(vm.ChooseElementCommand.CanExecute(null),
                "Cannot execute ChooseElementCommand");

            bool messageSent = false;
            vm.ElementChosenMessage.Sent += (sender, args) =>
            {
                messageSent = true;
                ViewModelBase messageContentVM = args.Content.ViewModel as ViewModelBase;
                Assert.AreEqual(expectedLabel, messageContentVM.DisplayString);
            };

            vm.ChooseElementCommand.Execute(null);
            Assert.IsTrue(messageSent, "No message was sent when element was chosen");
        }
    }
}
