﻿/* SelectEachDay.cs
 * part of zaaReloaded2
 * 
 * Copyright 2015 Daniel Kraus
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;

namespace zaaReloaded2.Controller.Elements
{
    [Serializable]
    public class SelectEachDay : ControlElementBase
    {
        public override string Label
        {
            get { return "Jeder Tag"; }
        }

        public override void Run(Formatter.Formatter formatter)
        {
            formatter.ProcessEachDay(this);
        }

        protected override ElementBase CreateInstance()
        {
            return new SelectEachDay(CloneChildren());
        }

        #region Constructors
        
        public SelectEachDay() : base() { }

        public SelectEachDay(FormatElementBase formatElement)
            : base(formatElement)
        { }

        public SelectEachDay(IList<FormatElementBase> formatElements)
            : base(formatElements)
        { }

        /// <summary>
        /// Deserialization constructor.
        /// </summary>
        protected SelectEachDay(SerializationInfo info, StreamingContext context)
            : base(info, context)
        { }

        #endregion
    }
}
