﻿/* SelectFirstDay.cs
 * part of zaaReloaded2
 * 
 * Copyright 2015 Daniel Kraus
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;

namespace zaaReloaded2.Controller.Elements
{
    /// <summary>
    /// Selects the time points of the first day in a given Formatter
    /// object.
    /// </summary>
    [Serializable]
    public class SelectFirstDay : ControlElementBase, ISerializable
    {
        public override string Label
        {
            get { return "Erster Tag"; }
        }

        public override void Run(Formatter.Formatter formatter)
        {
            formatter.ProcessFirstDay(this);
        }

        protected override ElementBase CreateInstance()
        {
            return new SelectFirstDay(CloneChildren());
        }

        #region Constructors

        public SelectFirstDay() : base() { }

        public SelectFirstDay(FormatElementBase formatElement)
            : base(formatElement)
        { }

        public SelectFirstDay(IList<FormatElementBase> formatElements)
            : base(formatElements)
        { }

        /// <summary>
        /// Deserialization constructor.
        /// </summary>
        protected SelectFirstDay(SerializationInfo info, StreamingContext context)
            : base(info, context)
        { }

        #endregion
    }
}
