﻿/* IImporter.cs
 * part of zaaReloaded2
 * 
 * Copyright 2015 Daniel Kraus
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using zaaReloaded2.LabModel;

namespace zaaReloaded2.Importer
{
    public interface IImporter
    {
        /// <summary>
        /// Gets the Laboratory resulting from the data import.
        /// </summary>
        Laboratory Laboratory { get; set; }

        /// <summary>
        /// Indicates whether the import was successful.
        /// </summary>
        bool Success { get; }

        /// <summary>
        /// Imports laboratory data contained in a string.
        /// </summary>
        /// <param name="text">String with laboratory data.</param>
        void Import(string text);
    }
}
