﻿/* Preferences.cs
 * part of zaaReloaded2
 * 
 * Copyright 2015 Daniel Kraus
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace zaaReloaded2
{
    /// <summary>
    /// Holds user preferences.
    /// </summary>
    public class Preferences
    {
        #region Singleton

        public static Preferences Default
        {
            get
            {
                return _instance;
            }
        }

        static readonly Preferences _instance = new Preferences();

        static Preferences() { }

        #endregion

        #region Properties

        /// <summary>
        /// Gets or sets whether the add-in should not ask for
        /// item comments (i.e. typist mode).
        /// </summary>
        public bool SuppressItemCommentInteraction
        {
            get
            {
                return Properties.Settings.Default.SuppressItemCommentInteraction;
            }
            set
            {
                Properties.Settings.Default.SuppressItemCommentInteraction = value;
                Properties.Settings.Default.Save();
            }
        }

        #endregion

        #region Constructors

        protected Preferences()  { }

        #endregion
    }
}
