﻿/* Updater.cs
 * part of zaaReloaded2
 * 
 * Copyright 2015 Daniel Kraus
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace zaaReloaded2.Updater
{
    class Updater : Bovender.Versioning.Updater
    {
        protected override Bovender.Versioning.SemanticVersion GetCurrentVersion()
        {
            return Version.CurrentVersion();
        }

        protected override Uri GetVersionInfoUri()
        {
            return new Uri(Properties.Settings.Default.VersionInfoFile);
        }

        protected override string BuildDestinationFileName()
        {
            return System.IO.Path.Combine(
                DestinationFolder,
                DownloadUri.ToString().Split('/').Last()
                );
        }

    }
}
