﻿/* CategoryViewModel.cs
 * part of zaaReloaded2
 * 
 * Copyright 2015 Daniel Kraus
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Bovender.Mvvm.ViewModels;

namespace zaaReloaded2.ViewModels
{
    /// <summary>
    /// A simple view model that can be used to categorize items
    /// in a tree view. It has a custom DisplayString and holds
    /// a collection of child view model items.
    /// </summary>
    class CategoryViewModel : ViewModelBase
    {
        public IEnumerable<ViewModelBase> Children { get; private set; }

        public CategoryViewModel(string name, IEnumerable<ViewModelBase> children)
        {
            DisplayString = name;
            Children = children;
        }

        public override object RevealModelObject()
        {
            throw new NotImplementedException();
        }
    }
}
